//
// GrayCouncil
// Copyright 1996 by Trygve Isaacson. All Rights Reserved.
//
// This file contains the GrayCouncil PowerPlant test program's
// application class implementation.
//

#pragma once

#include <LApplication.h>

#include "GrayCouncilPP.h"

class MyApplication : public LApplication, LListener, LPeriodical
	{
	public:
		
		MyApplication();
		virtual ~MyApplication();
		
			// this overriding function performs application functions
			
		virtual Boolean		ObeyCommand(CommandT inCommand, void* ioParam);	
		
			// this overriding function returns the status of menu items
			
		virtual void		FindCommandStatus(CommandT inCommand,
								Boolean &outEnabled, Boolean &outUsesMark,
								Char16 &outMark, Str255 outName);

	virtual void	ListenToMessage(
							MessageT		inMessage,
							void			*ioParam);

		virtual void	SpendTime(const EventRecord &inMacEvent);

	protected:

		virtual void		StartUp();		// overriding startup functions

		void	PoseExampleDialog(UInt32 dialogIndex);
		void	SetupExampleDialog(UInt32 dialogIndex, LWindow* itsWindow);
		void	CleanupExampleDialog(UInt32 dialogIndex, LWindow* itsWindow);
		void	EnableDisableDialog(UInt32 dialogIndex, LWindow* itsWindow, Boolean enable);
		void	ToggleButtons(OSType buttonToDisable, OSType buttonToEnable);
		void	EnableDisablePane(OSType paneID, Boolean enable);

		UInt32		mCurrentDialogIndex;
		LWindow*	mCurrentDialog;

		AGAProgressIndicatorPP*	mProgressIndicator1;	// valid while it is idling
		AGAProgressIndicatorPP*	mProgressIndicator2;	// valid while it is idling
		Boolean					mMovingProgressOrigin;	// true if ind. 2 has moving origin
		Boolean					mSkipNext;				// toggle to make origin move slower than value
	};

