
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <OSUtils.h>
#include <QuickDraw.h>
#include <Sound.h>

#define NEED_MAC_STUFF 1

#include "Ninkasi:C++ util:generic.h"
#include "Ninkasi:C++ util:complete_window.h"
#include "ear_defines.h"
#include "ear_decl.h"
#include "ear_prototypes.h"

DEN_MOTHER_T chord_functions_den_mother;

#define ABS(x) ((x)<0 ? (-(x)) : (x))

void make_about_chord_window();

void fiddle_with_chord_voicing(int *chord,int n,int inversions_allowed,
	int open_voicings_allowed);
void describe_chord_function(char *s,int chord_root,int chord_type,int chord_name_preference);
void choose_chord_substitution(int *actual_type,int *actual_root,
		int difficulty,int major_or_minor);
void really_choose_chord_substitution(int *type,int difficulty,
		int s1,int d1,int s2,int d2,int s3,int d3,int s4,int d4);

void make_window(int dlog_resource_id,
    	Str255 param_text0,
    	Str255 param_text1,
    	Str255 param_text2,
    	Str255 param_text3,
    	DEN_MOTHER_T *den_mother);
void do_match_controls_to_preferences(int preferred_chord_names,
	      			WindowPtr the_window,
	      			char *decoder_string);

void root_to_solfeg(char *p,int root);
void type_to_solfeg(char *p,int the_type);

void root_to_name(char *p,int root);
void type_to_name(char *p,int the_type);


// root/0:11,type/1:7,root_enabled/0:11,type_enabled/1:7,ok,
// play_chord,t1,guess,icon,percent,fraction,clear_score,t2,
// previous,mods/1:6,play_root,play_scale,play_tonic,chord_type

#define N_ROOTS 12
#define N_TYPES 7
#define N_MODS 6

#define CHORD_FUNCTION_TYPE_NONDOM_MAJ 1
#define CHORD_FUNCTION_TYPE_DOM 2
#define CHORD_FUNCTION_TYPE_MIN 3
#define CHORD_FUNCTION_TYPE_HALF_DIM 4
#define CHORD_FUNCTION_TYPE_DIM 5
#define CHORD_FUNCTION_TYPE_AUG 6
#define CHORD_FUNCTION_TYPE_FLAT5 7



	void
chord_functions_den_mother(complete_window *my_complete_window)
	{
	  //--- decoder string for controls:
	  static char **decoder_string;
	  static int have_decoder_string = 0;

	  static int root_enabled[N_ROOTS] = {1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0};
	  static int type_enabled[N_TYPES] = {1, 1, 1, 0, 0, 0, 0};
	  static int mod_enabled[N_MODS] =   {1, 0, 0, 0, 0, 0};
	 
	  static int normal_type_major[N_ROOTS] = {
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- I
	  	CHORD_FUNCTION_TYPE_HALF_DIM,		//-- bII
	  	CHORD_FUNCTION_TYPE_MIN,		//-- II
	  	CHORD_FUNCTION_TYPE_AUG,		//-- bIII
	  	CHORD_FUNCTION_TYPE_MIN,		//-- III
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- IV
	  	CHORD_FUNCTION_TYPE_HALF_DIM,		//-- #IV
	  	CHORD_FUNCTION_TYPE_DOM,		//-- V
	  	CHORD_FUNCTION_TYPE_AUG,		//-- bVI
	  	CHORD_FUNCTION_TYPE_MIN,		//-- VI
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- bVII
	  	CHORD_FUNCTION_TYPE_HALF_DIM,		//-- VII
	  };
	  static int normal_type_minor[N_ROOTS] = {
	  	CHORD_FUNCTION_TYPE_MIN,		//-- I
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- bII
	  	CHORD_FUNCTION_TYPE_HALF_DIM,		//-- II
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- bIII
	  	CHORD_FUNCTION_TYPE_MIN,		//-- III
	  	CHORD_FUNCTION_TYPE_MIN,		//-- IV
	  	CHORD_FUNCTION_TYPE_AUG,		//-- #IV
	  	CHORD_FUNCTION_TYPE_DOM,		//-- V
	  	CHORD_FUNCTION_TYPE_NONDOM_MAJ,		//-- bVI
	  	CHORD_FUNCTION_TYPE_HALF_DIM,		//-- VI
	  	CHORD_FUNCTION_TYPE_DOM,		//-- bVII
	  	CHORD_FUNCTION_TYPE_DIM,		//-- VII
	  };


	  //--- their score:
	  static int ntries;
	  static int nright;
	  //--- keeping track of my current state:
	  static int first_time = 1;
	  static int they_have_chord_to_consider;
	  static int current_icon; 
	  static int ready_to_update,need_to_redraw,need_to_redraw_all,pressed_ok,
	  	redraw_mods_check_boxes,redraw_types_check_boxes,
	  	redraw_roots_check_boxes;
	  static int previous_chord_names = NORMAL_CHORD_NAMES;
	  static int previous_difficulty = -1;
	  static int user_preferred_difficulty = -1;
	  //--- parameters that determine what chords I play and how I play them:
	  #define TYPICAL_TEMPO 45
	  static double typical_tempo;
	  static int mean_note;
	  static int min_notes;
	  static int max_notes;
	  //--- about the current chord:
	  static int n_items,item[MAX_CHORD_ITEMS];
	  static int n_notes,chord[MAX_CHORD_ITEMS];
	  static int duration;
	  static int major_or_minor;
	  static int tonic;
	  static int *normal_type_this_mode = normal_type_major;
	  					// initialize just in case...
	  static int actual_root, //-- relative to the tonic
	  	     actual_type;
	  static int previous_root,previous_type;
	  static int previous_items[MAX_CHORD_ITEMS],previous_n_items;
	  static int have_previous_chord = 0;
	  //--- their guess:
	  static int guess_type = -1;
	  static int guess_root = -1;
	  static int valid_guess = 0;
	  static int guess_specified_a_type = 0;
	  
	  char nifty_name[100];
	  int nifty_index,avg,i,right,they_gave_answer,cleared_scores,
	  	changed_guess,
	  	chose_new_chord,
	  	play_stuff,play_root,play_scale,play_the_chord,play_tonic,
	  	activate_and_deactivate,changed_difficulty,
	  	match_controls_to_preferences;
	  GrafPtr save_graf;

	  
	  need_to_redraw = 0;
	  need_to_redraw_all = 0;
	  ready_to_update = 0;
	  pressed_ok = 0;
	  play_stuff = 0;
	  play_scale = 0;
	  play_root = 0;
	  play_tonic = 0;
	  play_the_chord = 0;
	  they_gave_answer = 0;
	  cleared_scores = 0;
	  changed_guess = 0;
	  chose_new_chord = 0;
	  redraw_mods_check_boxes = 0;
	  redraw_types_check_boxes = 0;
	  redraw_roots_check_boxes = 0;
	  changed_difficulty = 0;
	  match_controls_to_preferences = 0;

	  activate_and_deactivate = 0;
	  
	  	 
	  if (first_time) { //-- this happens the first time our window is created,
	  			// and also when it's been closed and recreated
	    int i,ii,ee;
	    first_time = 0;
	    previous_difficulty = difficulty;
	    user_preferred_difficulty = -1;
	    ntries = 0;
	    nright = 0;
	    current_icon = BLANK_ICON_ID;
	    typical_tempo = TYPICAL_TEMPO;
	    mean_note = 58;
	    min_notes = 3;
	    max_notes = 4;
	    they_have_chord_to_consider = 0;
	    have_previous_chord = 0;
	  }
	  
	  if (previous_chord_names != preferences.chord_names) {
	    need_to_redraw = 1;
	    match_controls_to_preferences = 1;
	  }
	  previous_chord_names = preferences.chord_names;
	  
	  if (!have_decoder_string) {
	    decoder_string = (char **) GetString((short) CHORD_FUNCTIONS_DLOG_ID);
	    if (!VALID_HANDLE(decoder_string))
	      bail_out("unable to get decoder string");
	    HLock((char **) decoder_string);
	    have_decoder_string = 1;
	  }
	  
	  if (previous_difficulty!=difficulty) {
	    changed_difficulty = 1;
	    user_preferred_difficulty = difficulty;
	  }

	  switch(my_complete_window->whassup) {
	    case complete_window_created:
	      need_to_redraw = 1;
	      need_to_redraw_all = 1;
	      if (user_preferred_difficulty != -1)
	        difficulty = user_preferred_difficulty; //--store in global variable
	      break;
	    case complete_window_redraw:
	      need_to_redraw = 1;
	      need_to_redraw_all = 1;
	      ready_to_update = 1; //-- main program does begin update & sets graf port
	      break;
	    case complete_window_action:
	      part_number_to_nifty_label(nifty_name,&nifty_index,
			*decoder_string,my_complete_window->part_number);
	      if (nifty_index != -999) {
	        if (strcmp(nifty_name,"ok")==0) {
	          pressed_ok = 1;
	        }
	        if (strcmp(nifty_name,"play_chord")==0) {
	          play_stuff = 1;
	          play_the_chord = 1;
	        }
	        if (strcmp(nifty_name,"play_scale")==0) {
	          play_stuff = 1;
	          play_scale = 1;
	        }
	        if (strcmp(nifty_name,"play_root")==0) {
	          play_stuff = 1;
	          play_root = 1;
	        }
	        if (strcmp(nifty_name,"play_tonic")==0) {
	          play_stuff = 1;
	          play_tonic = 1;
	        }
	        if (strcmp(nifty_name,"clear_score")==0) {
	          ntries = 0;
	          nright = 0;
	          cleared_scores = 1;
	          need_to_redraw = 1;
	          current_icon = BLANK_ICON_ID;
	        }
	        if (strcmp(nifty_name,"type")==0) {
	          guess_type = nifty_index;
	          changed_guess = 1;
	          guess_specified_a_type = 1;
	        }
	        if (strcmp(nifty_name,"root")==0) {
	          guess_root = nifty_index;
	          if (!guess_specified_a_type)
	            guess_type = -1;
	          if (guess_type == -1) {
	            guess_type = normal_type_this_mode[guess_root];
	          }
	          changed_guess = 1;
	        }
	        if (strcmp(nifty_name,"mods")==0) {
	          need_to_redraw = 1;
	          redraw_mods_check_boxes = 1;
		  if (nifty_index>=1 && nifty_index<=N_MODS)
		    mod_enabled[nifty_index-1] = !mod_enabled[nifty_index-1];
	        }
	        if (strcmp(nifty_name,"root_enabled")==0) {
	          need_to_redraw = 1;
	          redraw_roots_check_boxes = 1;
		  if (nifty_index>=0 && nifty_index<=N_ROOTS-1)
		    root_enabled[nifty_index] = !root_enabled[nifty_index];
	        }
	        if (strcmp(nifty_name,"type_enabled")==0) {
	          need_to_redraw = 1;
	          redraw_types_check_boxes = 1;
		  if (nifty_index>=1 && nifty_index<=N_TYPES)
		    type_enabled[nifty_index-1] = !type_enabled[nifty_index-1];
	        }
	      }//--end if they hit a valid control
	      break;
	    case complete_window_erase:
	      they_have_chord_to_consider = 0;
	      first_time = 1;
	      chord_functions_window_exists = 0;
	      return;
	  }

	  if (changed_guess) {
	    if ((guess_root != -1) && (guess_type != -1)) {
	      if (!valid_guess) {
	        activate_and_deactivate = 1; //-- activate the ok button
	        need_to_redraw = 1;
	      }
	      valid_guess = 1;
	    }
	  }

	  if (pressed_ok && valid_guess) {
	    
	    activate_and_deactivate = 1;  //-- now that they've pressed ok, dim it
	    valid_guess = 0;	
	    guess_specified_a_type = 0;
	    	    
	    right = (actual_root == guess_root) && (actual_type == guess_type);
	    // ambiguities in symmetric chords:
	    if (actual_type == guess_type && actual_root != guess_root) {
	      unsigned long l;
	      int d;
	      l = notes_to_quick_label(chord,n_notes);
	      d = ABS(actual_root-guess_root);
	      // diminished 7:
	      if (n_notes==4 && l==2403 && d%3==0) {
	        right = 1;
	        actual_root = guess_root;
	      }
	      // aug triad:
	      if (n_notes==3 && l==132 && d%4==0) {
	        right = 1;
	        actual_root = guess_root;
	      }
	    }
	    	    
	    ++ntries;
	    nright += right;
	    if (right) {
	      current_icon = CHECK_ICON_ID;
	    }
	    else {
	      current_icon = X_ICON_ID;
	    }
	    they_have_chord_to_consider = 0;
	    they_gave_answer = 1;
	    need_to_redraw = 1;
	    
	    have_previous_chord = 1;
	    previous_root = actual_root;
	    previous_type = actual_type;
	    copy_chord(previous_items,item,n_items);
	    previous_n_items = n_items;
	  }

	  if (need_to_redraw) {
	    if (!ready_to_update) {
	      GetPort(&save_graf);
	      SetPort(my_complete_window->the_window);
	    }
	    if (match_controls_to_preferences) {
	      do_match_controls_to_preferences(preferences.chord_names,
	      			my_complete_window->the_window,
	      			*decoder_string);
	    }
	    if (activate_and_deactivate || need_to_redraw_all) {
	      if (valid_guess)
	        activate_ctl_by_nifty_label(my_complete_window->the_window,
	        	"ok",1,*decoder_string);
	      else
	        deactivate_ctl_by_nifty_label(my_complete_window->the_window,
	        	"ok",1,*decoder_string);
	    }
	    if (redraw_roots_check_boxes || redraw_mods_check_boxes 
	    	|| redraw_types_check_boxes || need_to_redraw_all) {
	      int nifty_index;
	      char nifty_name[30];
	      if (redraw_roots_check_boxes || need_to_redraw_all) {
	        for (nifty_index=0; nifty_index<=N_ROOTS-1; nifty_index++) {
	          set_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "root_enabled",nifty_index,*decoder_string,root_enabled[nifty_index]);
	        }
	      }
	      if (redraw_types_check_boxes || need_to_redraw_all) {
	        for (nifty_index=1; nifty_index<=N_TYPES; nifty_index++) {
	          set_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "type_enabled",nifty_index,*decoder_string,type_enabled[nifty_index-1]);
	        }
	      }
	      if (redraw_mods_check_boxes || need_to_redraw_all) {
	        for (nifty_index=1; nifty_index<=N_MODS; nifty_index++) {
	          set_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "mods",nifty_index,*decoder_string,mod_enabled[nifty_index-1]);
	        }
	      }
	    }
	    if (have_previous_chord 
	        && (need_to_redraw_all || they_gave_answer)) {
	      char s[200];
	      Handle h;
	        get_item_by_nifty_label(my_complete_window->the_window,
	      		"previous",1,*decoder_string,&h);
	        if (VALID_HANDLE(h)) {
	          describe_chord_function(s+1,previous_root,previous_type,
	          	preferences.chord_names);
	          s[0] = strlen(s+1);
	          TextSize((short) 18);
	          TextFont(geneva);
	          SetIText(h,(unsigned char *) s);
		  normal_text_style();
	        }
	        get_item_by_nifty_label(my_complete_window->the_window,
	      		"chord_type",1,*decoder_string,&h);
	        if (VALID_HANDLE(h)) {
	          describe_chord(s+1,previous_n_items,previous_items);
	          s[0] = strlen(s+1);
	          TextSize((short) 9);
	          TextFont(geneva);
	          SetIText(h,(unsigned char *) s);
		  normal_text_style();
	        }
	        
	    }
	    if (need_to_redraw_all) {
	      normal_text_style();
	      refresh_text(my_complete_window,"t1",1,*decoder_string);
	      refresh_text(my_complete_window,"t2",1,*decoder_string);
	      normal_text_style();
	    }
	    if (they_gave_answer || cleared_scores || need_to_redraw_all) {
	      Handle h,hh;
	      Rect rr;
	      char s[50];
	      int i,tot;
	      get_item_by_nifty_label(my_complete_window->the_window,
	      		"percent",1,*decoder_string,&h);
	      if (VALID_HANDLE(h)) {
	        if (ntries>0) {
	          sprintf(s+1,"%d %c",(int) ((100.*nright)/((double) ntries)),'%');
	          s[0] = strlen(s+1);
	        }
	        else {
	          sprintf(s+1,"           ");
	          s[0] = strlen(s+1);
	        }
	        TextSize((short) 18);
	        TextFont(geneva);
	        SetIText(h,(unsigned char *) s);
	        normal_text_style();
	      }
	      get_item_by_nifty_label(my_complete_window->the_window,
	      		"fraction",1,*decoder_string,&h);
	      if (VALID_HANDLE(h)) {
	        if (ntries>0) {
	          sprintf(s+1,"%d / %d",(int) nright,(int) ntries);
	          s[0] = strlen(s+1);
	        }
	        else {
	          sprintf(s+1,"           ");
	          s[0] = strlen(s+1);
	        }
	        TextFont(geneva);
	        SetIText(h,(unsigned char *) s);
	        normal_text_style();
	      }
	      hh = GetIcon((short) current_icon);
	      if (VALID_HANDLE(hh)) {
	        get_rect_by_nifty_label(my_complete_window->the_window,
	      	       "icon",1,*decoder_string, &rr);
	        PlotIcon(&rr,hh);
	      }
	    }//--end if (they_gave_answer || cleared_scores || need_to_redraw_all) {
	    if (!ready_to_update) {
	      SetPort(save_graf);
	    }
	  }//---end if need to redraw
	  if (!they_have_chord_to_consider) {
	    int want7,ntries,too_many_tries,perfect5,can_omit_5,can_add_note,
	    	offset,i,keep_it,k;
	    int *note_in_scale;
	    double x,how_far_out;
	    
	    chose_new_chord = 1;
	    	    
	    ntries = 0;
	    do {
	      if (random_double()<.7) {
	        major_or_minor = 1;
	        normal_type_this_mode = normal_type_major;
	        note_in_scale = interval_is_in_major_scale;
	      }
	      else {
	        major_or_minor = 2;
	        normal_type_this_mode = normal_type_minor;
	        note_in_scale = interval_is_in_harmonic_minor_scale;
	      }
	      do {
	        actual_root = random_integer(12)-1;
	        switch(major_or_minor) {
	          case 1:
	            switch(actual_root) {
	              case 0: case 5: case 7: how_far_out=0; break;
	              case 2: how_far_out=1; break;
	              case 9: how_far_out=1.5; break;
	              case 4: how_far_out=2; break;
	              case 11: how_far_out=2.5; break;
	              case 10: how_far_out=2.5; break;
	              case 3: how_far_out=4; break;
	              case 8: how_far_out=5; break;
	              case 1: how_far_out=6; break;
	              case 6: how_far_out=8; break;
	            }
	            break;
	          case 2:
	            switch(actual_root) {
	              case 0: case 5: case 7: how_far_out=0; break;
	              case 2: how_far_out=1; break;
	              case 9: how_far_out=1.5; break;
	              case 4: how_far_out=2.5; break;
	              case 11: how_far_out=2.5; break;
	              case 10: how_far_out=1.5; break;
	              case 3: how_far_out=4; break;
	              case 8: how_far_out=5; break;
	              case 1: how_far_out=6; break;
	              case 6: how_far_out=8; break;
	            }
	            break;
	        }//--end switch(major_or_minor)
	        x = (random_double()+random_double()-1.);
	        if (x<0) x= -x;
	        keep_it = 15.*difficulty/((double) MAX_DIFFICULTY)*x
	        	>how_far_out;
	      }while(!root_enabled[actual_root] || !keep_it);
	      actual_type = normal_type_this_mode[actual_root];
	      ++ntries;
	      too_many_tries = (ntries>1000);
	    } while(!type_enabled[actual_type-1] && !too_many_tries);
	    if (too_many_tries) {
	      actual_root = 0;
	      actual_type = CHORD_FUNCTION_TYPE_NONDOM_MAJ;
	    }

	    //------ chord substitutions
	    {
	      int original_type,original_root;
	      original_type = actual_type;
	      original_root = actual_root;
	      choose_chord_substitution(&actual_type,&actual_root,difficulty,major_or_minor);
	      if (!type_enabled[actual_type-1] || !root_enabled[actual_root]) {
	        actual_type = original_type;
	        actual_root = original_root;
	      }
	    }

	    want7 = (
	                 (mod_enabled[0] && actual_type==CHORD_FUNCTION_TYPE_DOM)
	    	      || (mod_enabled[1] && actual_type!=CHORD_FUNCTION_TYPE_DOM)
	    	    )
	    	    && random_double()<.5;
	    if (!want7) {
	      //-- They're not telepathic
	      if (actual_type==CHORD_FUNCTION_TYPE_DOM
	      	  && !note_in_scale[make_0_to_11(actual_root+10)]
	      	  && note_in_scale[make_0_to_11(actual_root+11)])
	        actual_type=CHORD_FUNCTION_TYPE_NONDOM_MAJ;
	      if (actual_type==CHORD_FUNCTION_TYPE_NONDOM_MAJ
	      	  && !note_in_scale[make_0_to_11(actual_root+11)]
	      	  && note_in_scale[make_0_to_11(actual_root+10)])
	        actual_type=CHORD_FUNCTION_TYPE_DOM;
	      if (actual_type==CHORD_FUNCTION_TYPE_HALF_DIM)
	        actual_type=CHORD_FUNCTION_TYPE_DIM;
	    }
	    

	    n_items = 1;
	    switch(actual_type) {
	      case CHORD_FUNCTION_TYPE_NONDOM_MAJ:
	        item[0] = (want7 ? CHORD_MAJ7 : CHORD_MAJ_TRIAD); break;
	      case CHORD_FUNCTION_TYPE_DOM:
	        item[0] = (want7 ? CHORD_DOM7 : CHORD_MAJ_TRIAD); break;
	      case CHORD_FUNCTION_TYPE_MIN:
	        item[0] = (want7 ? CHORD_MIN7 : CHORD_MIN_TRIAD); break;
	      case CHORD_FUNCTION_TYPE_HALF_DIM:
	        item[0] = (want7 ? CHORD_HALF_DIM : CHORD_DIM_TRIAD); break;
	      case CHORD_FUNCTION_TYPE_DIM:
	        item[0] = (want7 ? CHORD_DIM7 : CHORD_DIM_TRIAD); break;
	      case CHORD_FUNCTION_TYPE_AUG:
	        item[0] = CHORD_AUG_TRIAD;
	        if (want7) {
	          n_items = 2;
	          item[1] = CHORD_ADD7;
	        }
	        break;
	      case CHORD_FUNCTION_TYPE_FLAT5:
	        item[0] = CHORD_FLAT5_TRIAD;
	        if (want7) {
	          n_items = 2;
	          item[1] = CHORD_ADD7;
	        }
	        break;
	    }

	    make_chord(chord,&n_notes,item,n_items);
	    
	    perfect5 = 1;
	    if (actual_type==CHORD_FUNCTION_TYPE_HALF_DIM
	    	|| actual_type==CHORD_FUNCTION_TYPE_DIM
	    	|| actual_type==CHORD_FUNCTION_TYPE_AUG
	    	|| actual_type==CHORD_FUNCTION_TYPE_FLAT5)
	      perfect5 = 0;
	    
	    //-- added notes
	    can_omit_5 = perfect5 && mod_enabled[5];
	    can_add_note = (n_notes<4 || (n_notes>=4 && can_omit_5))
	    		  && (mod_enabled[2] || mod_enabled[3] || mod_enabled[4]);
	    
	    if (can_add_note &&
	    	random_double()<0.5*difficulty/((double) MAX_DIFFICULTY)) {
	      int new_items[10],new_n_items,what_mod;
	      do {
	        what_mod = random_integer(3)+1;
	      } while (!mod_enabled[what_mod]);
	      copy_chord(new_items,item,n_items);
	      new_n_items = n_items;
	      if (n_notes>=4)
	        add_note_to_chord(new_items,&new_n_items,CHORD_NO5);
	      switch(what_mod) {
	        case 2:
	          add_note_to_chord(new_items,&new_n_items,CHORD_6); break;
	        case 3:
	          add_note_to_chord(new_items,&new_n_items,CHORD_9); break; 
	        case 4:
	          add_note_to_chord(new_items,&new_n_items,CHORD_11); break;
	      }
	      copy_chord(item,new_items,new_n_items);
	      n_items = new_n_items;
	      make_chord(chord,&n_notes,item,n_items);
	    }
	    
	    fiddle_with_chord_voicing(chord,n_notes,inversions_allowed,1);
            tonic = mean_note+(random_double()-.5)*6+(random_double()-.5)*6;
	    for (i=0; i<n_notes; i++) {
	      chord[i] += tonic+actual_root;
	    }
	    avg = avg_chord(chord,n_notes);
	    offset = 0;
	    if (avg>tonic+6) offset -= 12;
	    while (avg+offset-12.*random_double()>tonic)
	      offset -= 12;
	    while (avg+offset+12.*random_double()<tonic)
	      offset += 12;
	    for (i=0; i<n_notes; i++) {
	      chord[i] += offset;
	    }
	    duration = choose_duration(typical_tempo);
	    play_stuff = 1;
	    play_scale = 1;
	    play_the_chord = 1;
	    they_have_chord_to_consider = 1;
	    guess_type = -1;
	    guess_root = -1;
	  }
	  if (play_stuff) {
	    if (play_scale) {
	          int *what_scale;
	          int i,note;
	          if (major_or_minor==1)
	            what_scale = interval_is_in_major_scale;
	          else
	            what_scale = interval_is_in_minor_scale;
	          for (i=0; i<=12; i++) {
	            if (what_scale[make_0_to_11(i)]) {
	              note = tonic+i;
	              play_chord(1,my_snd_chan,&note,duration/16,1);
	            }
	          }
	          rest(duration/6);
	    }
	    if (play_tonic) {
	      play_chord(1,my_snd_chan,&tonic,duration/2,1);
	    }
	    if (play_the_chord) {
	      play_chord(n_notes,my_snd_chan,chord,duration,1);
	    }
	    if (play_root) {
	      int note;
	      note = tonic + actual_root;
	      play_chord(1,my_snd_chan,&note,duration,1);
	    }
	  }

	  //--- A second block of code for updating the window: the chord symbol
	  //	for their guess.  The reason it has to be down here is that
	  //	if we're moving on to the next chord, we wait until now to 
	  //	erase their previous guess, _after_ playing the new chord
	    if (changed_guess || need_to_redraw_all) {
	      Handle h;
	      char s[50];
	      int i;
	      if (!ready_to_update) {
	        GetPort(&save_graf);
	        SetPort(my_complete_window->the_window);
	      }
	      get_item_by_nifty_label(my_complete_window->the_window,
	      		"guess",1,*decoder_string,&h);
	      if (VALID_HANDLE(h)) {
	        describe_chord_function(s+1,guess_root,guess_type,
	        	preferences.chord_names);
	        s[0] = strlen(s+1);
	        TextSize((short) 18);
	        TextFont(geneva);
	        SetIText(h,(unsigned char *) s);
	        normal_text_style();
	      }
	      if (!ready_to_update) {
	        SetPort(save_graf);
	      }
	    }



	}

	void
describe_chord_function(char *s,int chord_root,int chord_type,
			int preferred_chord_names)
	{
	  char xxx[100];
	  strcpy(s,"");
	  if (chord_root == -1 && chord_type == -1) return;
	  switch(preferred_chord_names) {
	    case NORMAL_CHORD_NAMES:
	      root_to_name(s,chord_root);
	      break;
	    case CHORD_SOLFEG_SYSTEM:
	      root_to_solfeg(s,chord_root);
	      break;
	  }
	  if (chord_root != -1 && chord_type != -1 
	  	&& preferred_chord_names!=CHORD_SOLFEG_SYSTEM)
	    strcat(s,", ");
	  if (chord_type != -1) {
	    switch(preferred_chord_names) {
	      case NORMAL_CHORD_NAMES:
	        type_to_name(xxx,chord_type);
	        break;
	      case CHORD_SOLFEG_SYSTEM:
	        type_to_solfeg(xxx,chord_type);
	        break;
	    }
	    strcat(s,xxx);
	  }
	}

	void
choose_chord_substitution(int *actual_type,int *actual_root,int difficulty,int major_or_minor)
	{
	      switch(*actual_type) {
	        case CHORD_FUNCTION_TYPE_NONDOM_MAJ:
	          really_choose_chord_substitution(actual_type,difficulty,
	          	CHORD_FUNCTION_TYPE_DOM,1,CHORD_FUNCTION_TYPE_MIN,2,
	          	CHORD_FUNCTION_TYPE_HALF_DIM,3,CHORD_FUNCTION_TYPE_DIM,4);
	          break;
	        case CHORD_FUNCTION_TYPE_DOM: 
	          really_choose_chord_substitution(actual_type,difficulty,
	          	CHORD_FUNCTION_TYPE_NONDOM_MAJ,1,CHORD_FUNCTION_TYPE_MIN,1,
	          	CHORD_FUNCTION_TYPE_HALF_DIM,2,CHORD_FUNCTION_TYPE_DIM,3);
	          break;
	        case CHORD_FUNCTION_TYPE_MIN: 
	          really_choose_chord_substitution(actual_type,difficulty,
	          	CHORD_FUNCTION_TYPE_NONDOM_MAJ,2,CHORD_FUNCTION_TYPE_DOM,1,
	          	CHORD_FUNCTION_TYPE_HALF_DIM,1,CHORD_FUNCTION_TYPE_DIM,2);
	          break;
	        case CHORD_FUNCTION_TYPE_HALF_DIM: 
	          really_choose_chord_substitution(actual_type,difficulty,
	          	CHORD_FUNCTION_TYPE_NONDOM_MAJ,3,CHORD_FUNCTION_TYPE_DOM,2,
	          	CHORD_FUNCTION_TYPE_MIN,1,CHORD_FUNCTION_TYPE_DIM,1);
	          break;
	        case CHORD_FUNCTION_TYPE_DIM: 
	          really_choose_chord_substitution(actual_type,difficulty,
	          	CHORD_FUNCTION_TYPE_NONDOM_MAJ,3,CHORD_FUNCTION_TYPE_DOM,2,
	          	CHORD_FUNCTION_TYPE_MIN,1,CHORD_FUNCTION_TYPE_HALF_DIM,1);
	          break;
	      }
	      if (*actual_type==CHORD_FUNCTION_TYPE_DOM) {
	        // tritone, dim7, half-dim, aug, b5
	        if (random_double()<0.7*difficulty/((double) MAX_DIFFICULTY)) {
	          switch(random_integer(5)) {
	            case 1: //-- tritone substitution
	              *actual_root = make_0_to_11(*actual_root+6);
	              break;
	            case 2: //-- dim7 substitution
	              *actual_root = make_0_to_11(*actual_root+1);
	              *actual_type = CHORD_FUNCTION_TYPE_DIM;
	              break;
	            case 3: //-- half-dim substitution
	              *actual_root = make_0_to_11(*actual_root+4);
	              *actual_type = CHORD_FUNCTION_TYPE_HALF_DIM;
	              break;
	            case 4: //-- aug substitution
	              *actual_type = CHORD_FUNCTION_TYPE_AUG;
	              break;
	            case 5: //-- b5 substitution
	              *actual_type = CHORD_FUNCTION_TYPE_FLAT5;
	              break;
	          }
	        }
	      }
	}

	void
really_choose_chord_substitution(int *type,int difficulty,
		int s1,int d1,int s2,int d2,int s3,int d3,int s4,int d4)
	{
	  int x;
	  double y,q;
	  int s[4],d[4],ntries,too_many_tries;
	  s[0] = s1; s[1] = s2; s[2] = s3; s[3] = s4;
	  d[0] = d1; d[1] = d2; d[2] = d3; d[3] = d4;
	  if (random_double()>0.7*difficulty/((double) MAX_DIFFICULTY))
	    return;
	  q = 0.;
	  ntries = 0;
	  do {
	    x = random_integer(4)-1;
	    y = random_double()*difficulty/((double) MAX_DIFFICULTY)
	    	+q; //-- add q to encourage it to get an answer on low difficulty
	    		// levels
	    q += .01; 
	    ++ ntries;
	    too_many_tries = ntries>10;
	  } while (!too_many_tries && y*5<d[x]);
	  if (!too_many_tries)
	    *type = s[x];
	}
	
	void
do_match_controls_to_preferences(int preferred_chord_names,
	      			WindowPtr the_window,
	      			char *decoder_string)
	{
	  Handle h;
	  int i;
	  char s[100];
	  switch(preferred_chord_names) {
	    case NORMAL_CHORD_NAMES:
	      for (i=0; i<=11; i++) {
	        root_to_name(s+1,i);
	        s[0] = strlen(s+1);
	        get_item_by_nifty_label(the_window,"root",i,decoder_string,&h);
	        if (VALID_HANDLE(h) && strlen(s)>0)
	          SetCTitle((ControlHandle) h,(unsigned char *) s);
	      }
	      for (i=1; i<=7; i++) {
	        type_to_name(s+1,i);
	        s[0] = strlen(s+1);
	        get_item_by_nifty_label(the_window,"type",i,decoder_string,&h);
	        if (VALID_HANDLE(h) && strlen(s)>0)
	          SetCTitle((ControlHandle) h,(unsigned char *) s);
	      }
	      break;
	    case CHORD_SOLFEG_SYSTEM:
	      for (i=0; i<=11; i++) {
	        root_to_solfeg(s+1,i);
	        s[0] = strlen(s+1);
	        get_item_by_nifty_label(the_window,"root",i,decoder_string,&h);
	        if (VALID_HANDLE(h) && strlen(s)>0)
	          SetCTitle((ControlHandle) h,(unsigned char *) s);
	      }
	      for (i=1; i<=7; i++) {
	        type_to_solfeg(s+1,i);
	        s[0] = strlen(s+1);
	        get_item_by_nifty_label(the_window,"type",i,decoder_string,&h);
	        if (VALID_HANDLE(h) && strlen(s)>0)
	          SetCTitle((ControlHandle) h,(unsigned char *) s);
	      }
	      break;
	  }
	}

	void
root_to_name(char *p,int root)
	{
	  switch(make_0_to_11(root)) {
	    case 0: strcpy(p,"I"); break;
	    case 1: strcpy(p,"bII"); break;
	    case 2: strcpy(p,"II"); break;
	    case 3: strcpy(p,"bIII"); break;
	    case 4: strcpy(p,"III"); break;
	    case 5: strcpy(p,"IV"); break;
	    case 6: strcpy(p,"#IV"); break;
	    case 7: strcpy(p,"V"); break;
	    case 8: strcpy(p,"bVI"); break;
	    case 9: strcpy(p,"VI"); break;
	    case 10: strcpy(p,"bVII"); break;
	    case 11: strcpy(p,"VII"); break;
	    default: strcpy(p,""); break;
	  }
	}
	
	void
type_to_name(char *p,int the_type)
	{
	  switch(the_type) {
	    case CHORD_FUNCTION_TYPE_NONDOM_MAJ: strcpy(p,"nondominant major"); break;
	    case CHORD_FUNCTION_TYPE_DOM:	 strcpy(p,"dominant"); break;
	    case CHORD_FUNCTION_TYPE_MIN: 	 strcpy(p,"minor"); break;
	    case CHORD_FUNCTION_TYPE_HALF_DIM: 	 strcpy(p,"half-diminished"); break;
	    case CHORD_FUNCTION_TYPE_DIM: 	 strcpy(p,"diminished"); break;
	    case CHORD_FUNCTION_TYPE_AUG: 	 strcpy(p,"augmented"); break;
	    case CHORD_FUNCTION_TYPE_FLAT5:	 strcpy(p,"b5"); break;
	  }
	}
	
	void
root_to_solfeg(char *p,int root)
	{
	  switch(make_0_to_11(root)) {
	    case 0: strcpy(p,"d"); break;
	    case 1: strcpy(p,"g"); break;
	    case 2: strcpy(p,"r"); break;
	    case 3: strcpy(p,"b"); break;
	    case 4: strcpy(p,"m"); break;
	    case 5: strcpy(p,"f"); break;
	    case 6: strcpy(p,"k"); break;
	    case 7: strcpy(p,"s"); break;
	    case 8: strcpy(p,"j"); break;
	    case 9: strcpy(p,"l"); break;
	    case 10: strcpy(p,"p"); break;
	    case 11: strcpy(p,"t"); break;
	    default: strcpy(p,""); break;
	  }
	}
	
	void
type_to_solfeg(char *p,int the_type)
	{
	  switch(the_type) {
	    case CHORD_FUNCTION_TYPE_NONDOM_MAJ: strcpy(p,"o"); break;
	    case CHORD_FUNCTION_TYPE_DOM:	 strcpy(p,"a"); break;
	    case CHORD_FUNCTION_TYPE_MIN: 	 strcpy(p,"i"); break;
	    case CHORD_FUNCTION_TYPE_HALF_DIM: 	 strcpy(p,"e"); break;
	    case CHORD_FUNCTION_TYPE_DIM: 	 strcpy(p,"u"); break;
	    case CHORD_FUNCTION_TYPE_AUG: 	 strcpy(p,"au"); break;
	    case CHORD_FUNCTION_TYPE_FLAT5:	 strcpy(p,"ai"); break;
	  }
	}

