//---- preferences
struct {
  int note_names;
  int chord_names;
} preferences;

//-- options
int difficulty = 4; //-- Ordinarily, the main program is responsible for this variable,
			// and the workouts take their queues from it.  However, if the user
			// changes the difficulty while using a particular workout, that
			// workout then records that as the user's preferred difficulty
			// level; if the workout is closed and then reopened later, the
			// program stuffs that value back into the global variable.
int open_voicings_allowed = 1;
int inversions_allowed = 1;
//---- options & preferences ----
int spell_dim7_enharmonically = 1;

//---------------- mac sound stuff --------------------------
unsigned char my_wave_table[WAVE_TABLE_SIZE];
double temp_wave_table[WAVE_TABLE_SIZE];
int wave_table_size = WAVE_TABLE_SIZE;
int have_wave_table = 0;
int have_temp_wave_table = 0;
int pitch_offset = 0;
	/* call toolbox routines with pitch+pitch_offset; e.g. if you sampled
	   four periods of the waveform, pitch_offset = -24 for a two-octave
	   offset; (actually done in play_chord) */
long init_chan_list[NCHAN] = {initChan0,initChan1,initChan2,initChan3};
short kind_of_chan_list[NCHAN] = {waveTableSynth,waveTableSynth,waveTableSynth,waveTableSynth};
SndChannelPtr my_snd_chan[NCHAN];
int made_snd_chan[NCHAN] = {0,0,0,0};
int chans_used = 4;

int have_sample_storage = 0;
Handle sound_handle = (Handle) 0;

//------------- other stuff --------------
int resources_available = 0;


short normal_font_size = 12;
Style normal_text_face = 0;
short normal_font = systemFont;

int n_windows = 0;
complete_window *my_windows[MAX_WINDOWS];
complete_window *where_is_about_chord_complete_window;

int interval_window_exists = 0;
int chord_window_exists = 0;
int sing_interval_window_exists = 0;
int about_chord_window_exists = 0;
int about_ear_training_window_exists = 0;
int chord_help_window_exists = 0;
int inversions_window_exists = 0;
int chord_functions_window_exists = 0;
//---- major and minor scales
int interval_is_in_major_scale[] = {1,0,1,0,1,1,0,1,0,1,0,1};
int interval_is_in_minor_scale[] = {1,0,1,1,0,1,0,1,1,0,1,0};
int interval_is_in_harmonic_minor_scale[] = {1,0,1,1,0,1,0,1,1,0,0,1};

//---- communication between chord_den_mother and about_chord_den_mother:
 int have_previous_chord;
 int previous_n_items,previous_item[MAX_CHORD_ITEMS];
 int previous_n_notes,previous_chord[MAX_CHORD_ITEMS];
 int previous_root;

