

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <OSUtils.h>
#include <QuickDraw.h>
#include <Sound.h>

#define NEED_MAC_STUFF 1

#include "Ninkasi:C++ util:generic.h"
#include "Ninkasi:C++ util:complete_window.h"
#include "ear_defines.h"
#include "ear_decl.h"
#include "ear_prototypes.h"

DEN_MOTHER_T inversions_den_mother;

#define MAX_CHORDS 7

void fiddle_with_chord_voicing(int *chord,int n,int inversions_allowed,
	int open_voicings_allowed);

		
	void
inversions_den_mother(complete_window *my_complete_window)
	{
	  //--- decoder string for controls:
		// chords/1:7,inversions/0:3,icon,percent,fraction,clear_score,play_again
	  static char **decoder_string;
	  static int have_decoder_string = 0;
	  //--- their score:
	  static int ntries = 0;
	  static int nright = 0;
	  //--- keeping track of my current state:
	  static int first_time = 1;
	  static int they_have_chord_to_consider = 0;
	  static int play_it,play_bass,play_root,give_hint,type_of_hint,answer,they_did_something;
	  static int they_gave_answer,twiddle_radio_buttons,need_to_redraw,
	  		twiddle_check_boxes,need_to_redraw_all,ready_to_update,
	  		right,cleared_scores,changed_tempo;
	  static int current_icon = BLANK_ICON_ID; 
	  //--- parameters that determine what chords I play and how I play them:
	  #define TYPICAL_TEMPO 45
	  static double typical_tempo = TYPICAL_TEMPO;
	  static int mean_note = 67; // higher than in chords workout -- have to
	  				// be able to hear bass note
	  static int chord_enabled[MAX_CHORDS+1];
	  static int chord_types[] = {0,CHORD_MAJ_TRIAD,CHORD_MIN_TRIAD,CHORD_DIM_TRIAD,
	  	CHORD_DOM7,CHORD_MIN7,CHORD_MAJ7,CHORD_HALF_DIM};
	  	
	  static int made_about_chord_window = 0;
	  
	  //--- about the current chord:
	  static int what_inversion,what_chord,bass_note,basic,duration,root;
	  static int n_items,items[MAX_CHORD_ITEMS];
	  static int n_notes,chord[MAX_CHORD_ITEMS];
	  
	  char nifty_name[100];
	  int nifty_index,recognized;
	  GrafPtr save_graf;

	  they_did_something = 0;
	  give_hint = 0;
	  play_it = 0;
	  play_bass = 0;
	  play_root = 0;
	  they_gave_answer = 0;
	  twiddle_radio_buttons = 0;
	  twiddle_check_boxes = 0;
	  need_to_redraw = 0;
	  need_to_redraw_all = 0;
	  ready_to_update = 0;
	  cleared_scores = 0;
	  changed_tempo = 0;
	  
	  if (first_time) {
	    first_time = 0;
            for (int i=0; i<=MAX_CHORDS; i++) {
              chord_enabled[i] = (i!=0) && (i==1 || i==2 || i==4);
            }
	    have_previous_chord = 0;
	    made_about_chord_window = 0;
	  }
	  	  
	  if (!have_decoder_string) {
	    decoder_string = (char **) GetString((short) INVERSIONS_DLOG_ID);
	    if (!VALID_HANDLE(decoder_string))
	      bail_out("unable to get decoder string");
	    HLock((char **) decoder_string);
	    have_decoder_string = 1;
	  }
	  switch(my_complete_window->whassup) {
	    case complete_window_created:
	      need_to_redraw = 1;
	      need_to_redraw_all = 1;
	      break;
	    case complete_window_redraw:
	      need_to_redraw = 1;
	      need_to_redraw_all = 1;
	      ready_to_update = 1; //-- main program does begin update & sets graf port
	      break;
	    case complete_window_action:
	      part_number_to_nifty_label(nifty_name,&nifty_index,
			*decoder_string,my_complete_window->part_number);
	      if (nifty_index != -999) {
	        recognized = 0;
	        if (strcmp(nifty_name,"inversions")==0) {
	          recognized = 1;
	          they_gave_answer = 1;
	          need_to_redraw = 1;
	          answer = nifty_index;
	        }
	        if (strcmp(nifty_name,"chords")==0) {
	          twiddle_check_boxes = 1;
	          need_to_redraw = 1;
	          if (nifty_index>=0 && nifty_index<=MAX_CHORDS)
	            chord_enabled[nifty_index] = !chord_enabled[nifty_index];
	          recognized = 1;
	        }
	        if (strcmp(nifty_name,"play_again")==0) {
	          recognized = 1;
	          play_it = 1;
	        }
	        if (strcmp(nifty_name,"play_bass")==0) {
	          recognized = 1;
	          play_bass = 1;
	        }
	        if (strcmp(nifty_name,"play_root")==0) {
	          recognized = 1;
	          play_root = 1;
	        }
	        if (strcmp(nifty_name,"clear_score")==0) {
	          recognized = 1;
	          ntries = 0;
	          nright = 0;
	          need_to_redraw = 1;
	          cleared_scores = 1;
	          current_icon = BLANK_ICON_ID;
	        }
	        they_did_something = recognized;
	      }//--end if they hit a valid control
	      break;
	    case complete_window_erase:
	      they_have_chord_to_consider = 0;
	      first_time = 1;
	      inversions_window_exists = 0;
	      if (about_chord_window_exists && VALID_POINTER(where_is_about_chord_complete_window))
	        delete where_is_about_chord_complete_window;
	      return;
	  }//-- end switch(my_complete_window->whassup)


	  if (they_gave_answer) {
	    right = (answer == what_inversion);
	    ++ntries;
	    nright += right;
	    if (right) {
	      current_icon = CHECK_ICON_ID;
	    }
	    else {
	      current_icon = X_ICON_ID;
	    }
	    
	    they_have_chord_to_consider = 0;
	    
	    if (!have_previous_chord && !made_about_chord_window) {
	      made_about_chord_window = 1;
	      make_about_chord_window();
	      SelectWindow(my_complete_window->the_window);
	      	// bring attention back to me!
	    }
	    have_previous_chord = 1;
	    previous_root = root;
	    previous_n_notes = n_notes;
	    copy_chord(previous_chord,chord,n_notes);
	    previous_n_items = n_items;
	    copy_chord(previous_item,items,n_items);
	    //-- let about_chord_den_mother know it should redraw itself
	    if (about_chord_window_exists) {
	      GrafPtr save_graf;
	      WindowPtr window;
	      window = where_is_about_chord_complete_window->the_window;

	      SelectWindow(window);

	      GetPort(&save_graf);
	      SetPort(window);
	    
	      EraseRect(&window->portRect);
	      DrawControls(window);
	    
	      where_is_about_chord_complete_window->whassup
	    	 = complete_window_redraw;
	      (*(where_is_about_chord_complete_window->den_mother))
	    	(where_is_about_chord_complete_window);
	    
	      SetPort(save_graf);
	      
	      SelectWindow(my_complete_window->the_window);
	      	// bring attention back to me!
	    }

	  }
	  
	  if (need_to_redraw) {
	    if (!ready_to_update) {
	      GetPort(&save_graf);
	      SetPort(my_complete_window->the_window);
	    }
	    if (twiddle_radio_buttons || need_to_redraw_all) {
	    }
	    if (twiddle_check_boxes || need_to_redraw_all) {
              for (int i=1; i<=MAX_CHORDS; i++) {
	        set_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "chords",i,*decoder_string,chord_enabled[i]);
	      }
	    }
	    if (need_to_redraw_all) {
	      refresh_text(my_complete_window,"tx",1,*decoder_string);
	    }
	    if (they_gave_answer || cleared_scores || need_to_redraw_all) {
	      Handle h;
	      char s[50];
	      int i,tot;
	      get_item_by_nifty_label(my_complete_window->the_window,
	      		"percent",1,*decoder_string,&h);
	      if (VALID_HANDLE(h)) {
	        if (ntries>0) {
	          sprintf(s+1,"%d %c",(int) ((100.*nright)/((double) ntries)),'%');
	          s[0] = strlen(s+1);
	        }
	        else {
	          sprintf(s+1,"           ");
	          s[0] = strlen(s+1);
	        }
	        TextSize((short) 18);
	        TextFont(geneva);
	        SetIText(h,(unsigned char *) s);
	        normal_text_style();
	      }
	      get_item_by_nifty_label(my_complete_window->the_window,
	      		"fraction",1,*decoder_string,&h);
	      if (VALID_HANDLE(h)) {
	        if (ntries>0) {
	          sprintf(s+1,"%d / %d",(int) nright,(int) ntries);
	          s[0] = strlen(s+1);
	        }
	        else {
	          sprintf(s+1,"           ");
	          s[0] = strlen(s+1);
	        }
	        TextFont(geneva);
	        SetIText(h,(unsigned char *) s);
	        normal_text_style();
	      }
	      
	    }//--end if (they_gave_answer || cleared_scores || need_to_redraw_all) {
	    if (they_gave_answer) {
	      int i;
	      if (!right) {
                for (i=0; i<=3; i++) {
	          if (i!=what_inversion)
	            hide_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "inversions",i,*decoder_string);
	        }
	      }
	    }
	    if (they_gave_answer || cleared_scores || need_to_redraw_all) {
	      Handle hh;
	      Rect rr;
	      hh = GetIcon((short) current_icon);
	      if (VALID_HANDLE(hh)) {
	        get_rect_by_nifty_label(my_complete_window->the_window,
	      	       "icon",1,*decoder_string, &rr);
	        PlotIcon(&rr,hh);
	      }
            }
	    if (they_gave_answer && !right) {
	      int i;
	      rest((int)( 1. * 2000.*60./typical_tempo));
              for (i=0; i<=3; i++) {
	        if (i!=what_inversion)
	          show_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "inversions",i,*decoder_string);
	      }
	    }
	    if (they_gave_answer && !right) {
	      int i;
	      rest((int)( 1. * 2000.*60./typical_tempo));
              for (i=0; i<=3; i++) {
	        if (i!=what_inversion)
	          show_ctl_by_nifty_label(my_complete_window->the_window,
	    	         "inversions",i,*decoder_string);
	      }
	    }
	    if (!ready_to_update) {
	      SetPort(save_graf);
	    }
	  }//---end if need to redraw
	  if (!they_have_chord_to_consider) {
	    	    
	    n_items = 1;
	    do {
	      what_chord = random_integer(MAX_CHORDS);
	      items[0] = chord_types[what_chord];
	    } while(!chord_enabled[what_chord]);
	    make_chord(chord,&n_notes,items,n_items);  //-- close, root position
	    root = 0;
	    //--- possible doubling of root
	    if (n_notes<4 && random_double()<.3)
	      add_note_to_chord(chord,&n_notes,root+12);

	    what_inversion = random_integer(n_notes)-1;

	    basic = find_basic_chord(items,n_items);
	    switch(what_inversion) {
	      default:
	      case 0:     bass_note = 0;     break;
	      case 1:     bass_note = what_is_3_of_chord(basic);     break;
	      case 2:     bass_note = what_is_5_of_chord(basic);     break;
	      case 3:     bass_note = what_is_7_of_chord(basic);     break;
	    }
	    
	    //--Bring correct note down into bass.
	    {
	      int i,lowest_note_besides_bass,which_note_is_bass;
	      lowest_note_besides_bass = 999;
	      for (i=0; i<n_notes; i++) {
	        if (make_0_to_11(chord[i])==bass_note)
	          which_note_is_bass=i;
	        if (make_0_to_11(chord[i])!=bass_note
	        			 && chord[i]<lowest_note_besides_bass)
	          lowest_note_besides_bass = chord[i];
	      }
	      while(chord[which_note_is_bass]>lowest_note_besides_bass)
	        chord[which_note_is_bass] -= 12;
	    }
	    make_close_voicing(chord,chord,n_notes); //--Bring back to close voicing.
	    fiddle_with_chord_voicing(chord,n_notes,0,1); //--now maybe open voicing
	    	    
	    //--offset whole chord
	    {
	      int i,center,avg;
              center = mean_note+(random_double()-.5)*6+(random_double()-.5)*6;
	      avg = avg_chord(chord,n_notes);
	      root += center-avg;
	      for (i=0; i<n_notes; i++)
	        chord[i] += center-avg;
	    }
	    duration = choose_duration(typical_tempo);
	    
	    play_it = 1;
	    they_have_chord_to_consider = 1;
	  }//--end if !they_have_chord_to_consider
	  
	  if (play_it) {
	    play_chord(n_notes,my_snd_chan,chord,duration,1);
	  }
	  if (play_bass) {
	    play_chord(1,my_snd_chan,&(chord[0]),duration,1);
	  }
	  if (play_root) {
	    play_chord(1,my_snd_chan,&root,duration,1);
	  }

	}

