#############################################################################
#############################################################################
#
# latexMode.tcl (called from modes.tcl at startup)
#
#############################################################################
#############################################################################

set latexVersion "2e"
catch { enableMenuItem install "LaTeX 2e" off }
catch { enableMenuItem install "LaTeX 2.09" on }

set dummyProc(TeX) dummyTeX

# Reset the search path so it will be rebuilt the next time it's needed:
set TeXSearchPath {}

# Initialize TeX-related application signatures:
foreach app {tex viewDVI printDVI dvips viewPS printPS bibtex makeindex} {
	if { ![info exists ${app}Sig] } {
		set ${app}Sig {}
	}
}

# Initialize LaTeX menus:
proc latexMenu {} {}
set latexMenu "270"
# (other menus initialized in latexMenu.tcl)

# Install the short LaTeX menu, by default:
set useShortLaTeXMenu 1

set modeMenus(TeX) latexMenu

# Global variable for reference completion:
set __wc__insPos -1

# Remember, Alpha's mode suffix mechanism is case-sensitive...
addMode TeX dummyTeX {*.tex *.ltx *.dtx *.ins *.cls *.clo *.sty *.log *.aux *.bbl *.idx *.ind *.glo *.gls *.toc *.lof *.lot *.blg *.ilg } latexMenu
addMenu latexMenu

# Clean up temporary files:
proc removeTemporaryFiles {} {
	global PREFS
	if { [file exists "$PREFS:tmp"] } {
		foreach f [glob -nocomplain "$PREFS:tmp:*"] {
			message "removing [file tail $f]"
			removeFile $f
		}
	}
	message "all temporary files removed"
}
if { $startingUp } { removeTemporaryFiles }
                         
#--------------------------------------------------------------------------
# Event hooks
#--------------------------------------------------------------------------

if { [info commands TeXChangeMode] == "" } {
	rename changeMode TeXChangeMode
}
# This is called for all open, saveas, and activate events:
proc changeMode {newMode} {	
	if { $newMode == "TeX" } {
		dummyTeX
		eval [typesetSubmenu]
	}
	TeXChangeMode $newMode
}
